package androidvoicerecordingwrapper;

import android.annotation.SuppressLint;
import android.app.Activity;
import android.content.Intent;
import android.os.Build;
import android.os.Bundle;
import android.view.View.OnClickListener;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemSelectedListener;
import android.widget.Toast;

import com.skd.androidrecording.visualizer.VisualizerView;
import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.drawable.Drawable;
import android.util.DisplayMetrics;
import android.view.ViewGroup;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BA.Author;
import anywheresoftware.b4a.BA.Hide;
import anywheresoftware.b4a.BA.Pixel;
import anywheresoftware.b4a.BA.ShortName;
import anywheresoftware.b4a.BA.Version;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.BA.DependsOn;
import anywheresoftware.b4a.keywords.Common.DesignerCustomView;
import anywheresoftware.b4a.objects.LabelWrapper;
import anywheresoftware.b4a.objects.PanelWrapper;
import anywheresoftware.b4a.objects.ViewWrapper;
import anywheresoftware.b4a.objects.TextViewWrapper;
import anywheresoftware.b4a.BA.Events;
import anywheresoftware.b4a.BA.ActivityObject;

import android.graphics.Color;
import android.graphics.Paint;

//import android.graphics.Typeface;

import com.skd.androidrecording.audio.AudioRecordingHandler;
import com.skd.androidrecording.audio.AudioRecordingThread;
import com.skd.androidrecording.visualizer.VisualizerView;
import com.skd.androidrecording.visualizer.renderer.BarGraphRenderer;
import com.skd.androidrecording.utils.NotificationUtils;
import com.skd.androidrecording.utils.StorageUtils;

import android.view.View;
import android.view.Gravity; 



@ActivityObject
//@Events(values={"value_changed(retval as Float)"})
@Author("Github: Julia Zudikova, Wrapped by: Johan Schoeman")
@Version(1.00f)
@ShortName("VisualizerView")
@DependsOn(values={"android-support-v4","simplesound-0.1"})
public class androidVoiceRecordingWrapper extends ViewWrapper<VisualizerView> implements DesignerCustomView {


	private BA ba;
	private String eventName;
        private VisualizerView cv;
	private AudioRecordingThread recordingThread;
	private boolean startRecording = true;
	private String fileName = "Bollie";
        private StorageUtils su;


	public void Initialize(BA ba, String EventName) {
		_initialize(ba, null, EventName);
	}



	@Hide
	public void _initialize(BA ba, Object activityClass, String EventName) {
		this.eventName = EventName.toLowerCase(BA.cul);
		this.ba = ba;
		cv = new VisualizerView(ba.context);
                this.setObject(cv);
                su = new StorageUtils();

		if (!su.checkExternalStorageAvailable()) {
			NotificationUtils.showInfoDialog(ba.context, "No Extenal Storage Available");
			return;
		}
//              addListener();
//              addListener2();
 	}



    public void setRecordingFileName(String RecordingFileName){
                su.setFileName(RecordingFileName);
                fileName = su.getFileName(true);
    }


    public void ReleaseResources() {
	recordStop();
	releaseVisualizer();
    }

    private void stopRecording() {
    	if (recordingThread != null) {
    		recordingThread.stopRecording();
    		recordingThread = null;
	}
    }
	

       private int VisualizerColor = Color.argb(200, 227, 69, 53);
       /**
        * Set the color of the visualizer bars
        * The default color is Color.argb(200, 227, 69, 53)
        */
       public void setVisualizerColor(int VisualizerColor){
           this.VisualizerColor = VisualizerColor;
       }

       private float VisualizerBarWidth = 5.0f;
       /**
        * Set the width of the visualizer bars
        * The default value is 5.0f
        */
       public void setVisualizerBarWidth(float VisualizerBarWidth){
           this.VisualizerBarWidth = VisualizerBarWidth;
       }

       private int VisualizerDivisions = 2;
       /**
        * divisions - must be a power of 2 (i.e 2, 4, 8, etc). Controls how many lines to draw
        * The default value is 2
        */
       public void setVisualizerDivisions(int VisualizerDivisions){
           this.VisualizerDivisions = VisualizerDivisions;
       }

       private boolean DrawBarsFromTop = false;
       /**
        * Draw the bars from the top or bottom of the view
        * The default value false
        */
       public void setDrawBarsFromTop(boolean DrawBarsFromTop){
           this.DrawBarsFromTop = DrawBarsFromTop;
       }

	public void setupVisualizer() {
	       Paint paint = new Paint();
               paint.setStrokeWidth(VisualizerBarWidth);
               paint.setAntiAlias(true);
               paint.setColor(VisualizerColor);
               BarGraphRenderer barGraphRendererBottom = new BarGraphRenderer(VisualizerDivisions, paint, DrawBarsFromTop);
               cv.addRenderer(barGraphRendererBottom);
	}
	
	private void releaseVisualizer() {
		cv.release();
		cv = null;
	}

	public void StartStopRecording() {
            if (startRecording) {
        	recordStart();
            } else {
        	recordStop();
            }
	}
	
	private void recordStart() {
		startRecording();
    	        startRecording = false;
    	        //recordBtn.setText(R.string.stopRecordBtn);
    	        //playBtn.setEnabled(false);
	}
	
	private void recordStop() {
		stopRecording();
		startRecording = true;
    	        //recordBtn.setText(R.string.recordBtn);
    	        //playBtn.setEnabled(true);
	}
	
	private void startRecording() {
	    recordingThread = new AudioRecordingThread(fileName, new AudioRecordingHandler() {
			@Override
			public void onFftDataCapture(final byte[] bytes) {
				ba.activity.runOnUiThread(new Runnable() {
					public void run() {
						if (cv != null) {
							cv.updateVisualizerFFT(bytes);
						}
					}
				});
			}

			@Override
			public void onRecordSuccess() {}

			@Override
			public void onRecordingError() {
				ba.activity.runOnUiThread(new Runnable() {
					public void run() {
						recordStop();
						NotificationUtils.showInfoDialog(ba.context, "Recording Error");
					}
				});
			}

			@Override
			public void onRecordSaveError() {
				ba.activity.runOnUiThread(new Runnable() {
					public void run() {
						recordStop();
						NotificationUtils.showInfoDialog(ba.context, "Save Record Error");
					}
				});
			}
		});
	    recordingThread.start();
    }
    

//    public void play() {
//		Intent i = new Intent(AudioRecordingActivity.this, AudioPlaybackActivity.class);
//		i.putExtra(VideoPlaybackActivity.FileNameArg, fileName);
//		startActivityForResult(i, 0);
//   }



//    @Hide
//    public void addListener(){

//        cv.setCallback(new Wheel.Callback() {
//            @Override
//            public void value_changed() {

//              if (ba.subExists(eventName + "_value_changed")) {
//                ba.raiseEvent2(ba, false, eventName + "_value_changed", true, new Object[]{retval});
//              }
//            }

//            @Override
//            public void started() {

//              if (ba.subExists(eventName + "_click")) {
//                ba.raiseEvent2(ba, false, eventName + "_click", true, new Object[0]);
//              }
//            }


//        });
//    }


//      @Hide
//      public void addListener2(){
//        cv.setOnClickListener(new View.OnClickListener() {
//            @Override
//            public void onClick(View v) {
//              if (ba.subExists(eventName + "_button_clicked")) {
//                ba.raiseEvent2(ba, false, eventName + "_button_clicked", true, new Object[0]);
//              }
//            }
//        });
//      }

//    public void addImage(String draw) {
//		 int DrawableID = BA.applicationContext.getResources().getIdentifier(draw, "drawable", BA.packageName);
//               cv.setForeground(DrawableID);
//		 Drawable drawable = BA.applicationContext.getResources().getDrawable(DrawableID);
//                 cv.setForeground(drawable); 
//    }









	
	//programmatically add view
        @Hide
	public void AddToParent(ViewGroup Parent, @Pixel int left, @Pixel int top, @Pixel int width, @Pixel int height) {
		Parent.addView(cv, new BALayout.LayoutParams(left, top, width, height));
	}
	
	//this method cannot be hidden.
  
        
	public void DesignerCreateView(PanelWrapper base, LabelWrapper lw, anywheresoftware.b4a.objects.collections.Map props) {
		ViewGroup vg = (ViewGroup) base.getObject().getParent();
		AddToParent(vg, base.getLeft(), base.getTop(), base.getWidth(), base.getHeight());
		base.RemoveView();
		//set text properties
	}



	public void setLeft(int left)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.left = left;
		cv.getParent().requestLayout();
	}

	public int getLeft()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.left;
	}
	public void setTop(int top)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.top = top;
		cv.getParent().requestLayout();
	}
 
	public int getTop()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.top;
	}
	
	public void setWidth(int Width)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.width = Width;
		cv.getParent().requestLayout();
	}

	public int getWidth()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.width;
	}
	
	public void setHeight(int height)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.height = height;
		cv.getParent().requestLayout();
	}

	public int getHeight()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.height;
	}

   
}
